/***************************************************************************
                          bookmarkcombobox.h  -  description
                             -------------------
    begin                : Fri Dec 14 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef BOOKMARKCOMBOBOX_H
#define BOOKMARKCOMBOBOX_H

#include <qwidget.h>
#include <qcombobox.h>
#include <qsettings.h>

/**
  *@author Christian Fricke & Ren Mrten
  */

class bookmarkComboBox : public QComboBox  {
   Q_OBJECT
public: 
	bookmarkComboBox(const char *name, QWidget *parent=0);
	~bookmarkComboBox();
	void insertItem(QString,int index = -1);
private:
  QString n; // Name!
public slots:
  void    textChanged(const QString &);
  void    reRead();
private slots:
  void    activated(int);
  void    keyReleaseEvent(QKeyEvent *e);
  void    keyPressEvent(QKeyEvent *e);
signals:
  void    commandBoxReady();
  void    itemRequested();
  void    doCommand(const QString &);
  void    cursorRequested(QKeyEvent *);
};

#endif
