/****************************************************************************
                          dlgcopy.h  -  description
                             -------------------
    begin                : Fri Dec 14 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
****************************************************************************/

#ifndef MYDIALOG_H
#define MYDIALOG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qvariant.h>   // first for gcc 2.7.2
#include <qlabel.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qstrlist.h>
#include <qtimer.h>
#include <qlineedit.h>

#include <kclistview.h>
#include <kciconview.h>
#include <kcview.h>
#include <dlgoverwrite.h>

/**
  *@author Christian Fricke & Ren Mrten
  */

class dlgCopy : public QDialog
{ 
    Q_OBJECT

public:
    dlgCopy(  bool copy, // false == move
              kcView *from, kcView *to, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
//DND Kostruktor
    dlgCopy( QStrList,QString, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
//////////////////
    ~dlgCopy();

    QProgressBar  *ProgressBar1,
                  *ProgressBar2,
                  *ProgressBar3;
    QLabel        *TextLabel1,
                  *TextLabel2,
                  *TextLabel3,
                  *actionLabel,
                  *TextLabel5,
                  *TextLabel6;
    QPushButton   //*buttonHelp,
                  //*buttonOk,
                  *buttonCancel;
    QLineEdit     *leDestination;

protected:
    QHBoxLayout   *Layout1;
    QHBoxLayout   *Layout10;
    QVBoxLayout   *dlgCopyLayout;
private:
    void          getRecursiveList();
    void          recurse(QString path);
    kcView    *source, *dest;
    QStrList      *liste;
    QTimer        *time;
    int           files, dirs;
    double        bytes;
    bool          breakFlag;
    int           option;
    bool          copyflag;
private slots:
    void          started();
    void          startCopy();
    void          cancelPressed();
signals:
    void          dirDeleted(const char *, const char *);

// DND Implementation
private slots:
    void          startedDND();
    void          startCopyDND();
private:
    void          getRecursiveListDND();
    QStrList    SourceList;
    QString     DestString;
};

#endif // dlgCopy_H
