/***************************************************************************
                          kcdiroperator.h  -  description
                             -------------------
    begin                : Fri Dec 14 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef KCDIROPERATOR_H
#define KCDIROPERATOR_H

// QT Includes
#include <qobject.h>
#include <qstrlist.h>
#include <qtimer.h>
#include <qdir.h>
#include <qprocess.h>
#include <qfileinfo.h>
#include <qapplication.h>

// Own Includes
#include "kccommon.h"

/**This is the mainclass for read in directorys.
It supports local, ftp and SMB
  *@author Christian Fricke & Ren Mrten
  */

class kcDirOperator : public QObject  {
 Q_OBJECT
public:
	kcDirOperator();
	~kcDirOperator();
  void            readDir(const QString);
  void            setname(QString);    //brauch ich eineindeutig    //kann nicht private werden, weil im Moment noch der Name des Tempfiles hierdurch bestimmt wird !!
  void            reRead();    // Wird benutzt von den Views, wenn z.B. was reinkopiert wurde .. also was soll ich tun :(
  QString       dirname(){return directory;};
private:
  QString         directory;
  bool            inZipFile;
  void            removeTmpDir();


// NEW for the next DirOperatorVersion
public:
//  QStrList        readDir(const QString);
//  bool            copyFrom(const QString destDir);
//  bool            copyTo(const QString sourceFile);
//  bool            renameDir(const QString oldName, const QString newName);
//  bool            renameFile(const QString oldName, const QString newName);
//  bool            remDir(const QString dirName, bool recursiv=false);
//  bool            remFile(const QString dirName);
// darf es so nicht mehr geben
//  bool            reRead();


signals:
  // Wir geben zurck, eine Liste von fileinfo-structs
  void            gotFileList( QPtrList<struct_fileinfo> *);
  void            gotFile( const struct_fileinfo *);
  void            dirReady();
  void            dirNotExist();
private:
  void            readDirLocal();
  void            readLocalZipfile(QString);
  void            continueReadLocalZipfile(QString);

  void            readDirFtp();
  void            readDirSmb();
  bool            sambaWorking();
  QProcess        *proc;

  QString		zipName;

private slots:
  void            readFromStdout();
  void            readFromStderr();
};
#endif

/*
  connect(dirOperator,SIGNAL(gotFileList(QPtrList<struct_fileinfo> *)),
        SLOT(gotFileList(QPtrList<struct_fileinfo> *)));
*/