/***************************************************************************
                          kcedit.cpp  -  description
                             -------------------
    begin                : Sun Jan 6 2002
    copyright            : (C) 2002 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#include "kcedit.h"

#include <qfileinfo.h>

kcEdit::kcEdit(QString fileName, int type)
{
   wdg = new QWidget();
	
	QFileInfo info(fileName);
	if(type == 1)
	{

     statusbar = new QStatusBar(wdg);
     stat_fsize = new statusLineEntry(statusbar);
     stat_filepos = new statusLineEntry(statusbar);
     statusbar->addWidget(stat_fsize,200,true);
     statusbar->addWidget(stat_filepos,200,true);
	
     QBoxLayout * l = new QVBoxLayout( wdg);

	  hex = new hexViewEdit(QString(fileName),true,wdg);
     l->addWidget( hex );
     l->addWidget(statusbar );
	
     connect(hex, SIGNAL(info1changed(QString)), SLOT(setInfo1(QString)));
     connect(hex, SIGNAL(info2changed(QString)), SLOT(setInfo2(QString)));
     connect(hex, SIGNAL(closeParent()), SLOT(closeHexEdit()));

	  wdg->show();
	}
	else if(info.extension(true) == "jpg" ||info.extension(true) == "jpeg" ||info.extension(true) == "png" ||info.extension(true) == "bmp" ||info.extension(true) == "xpm")
	{
      ImageViewer *im = new ImageViewer(true,0,"title",Qt::WDestructiveClose);
      im->show();
      im->loadImage(fileName);
      im->resize(640,480);
   }
   else
   {
      te1 = new kcTextEdit();
      te1->load(fileName);
      te1->resize(640,480);
      te1->show();
   }
}

kcEdit::~kcEdit()
{
  delete wdg;
}

void kcEdit::setInfo1(QString s)
{
  stat_fsize->setText(s);
}
void kcEdit::setInfo2(QString s)
{
  stat_filepos->setText(s);
}

void kcEdit::closeHexEdit()
{
  wdg->close();
}
