/***************************************************************************
                          kcfileiconprovider.cpp  -  description
                             -------------------
    begin                : Wed Dec 26 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/

#include "kcfileiconprovider.h"

#include <qregexp.h>
#include "icons.h"

static QPixmap *iconUnknown = 0;
static QPixmap *iconPicture = 0;
static QPixmap *iconPacked = 0;
static QPixmap *iconWeb = 0;
static QPixmap *iconRpm = 0;
static QPixmap *iconText = 0;
static QPixmap *iconCpp = 0;
static QPixmap *iconDoc = 0;
static QPixmap *iconH = 0;
static QPixmap *iconMoc = 0;
static QPixmap *iconO = 0;
static QPixmap *iconMake = 0;
static QPixmap *iconResource = 0;
static QPixmap *iconLog = 0;
static QPixmap *iconPs = 0;
static QPixmap *iconPdf = 0;
static QPixmap *iconFilm = 0;
static QPixmap *iconSound = 0;
static QPixmap *iconJava = 0;
static QPixmap *iconConfigs = 0;
static QPixmap *iconUp = 0;
static QPixmap *iconHome = 0;
static QPixmap *iconSfile = 0;
static QPixmap *iconFolder = 0;
static QPixmap *iconSfolder = 0;

static QPixmap *bgpixmap = 0;


kcFileIconProvider::kcFileIconProvider()
{
  iconUnknown = new QPixmap(unknown_xpm);
  iconPicture = new QPixmap(picture_xpm);
  iconPacked = new QPixmap(packed_xpm);
  iconWeb = new QPixmap(web_xpm);
  iconRpm = new QPixmap(rpm_xpm);
  iconText = new QPixmap(txt_xpm);
  iconCpp = new QPixmap(cpp_xpm);
  iconDoc = new QPixmap(doc_xpm);
  iconH = new QPixmap(h_xpm);
  iconMoc = new QPixmap(moc_xpm);
  iconO = new QPixmap(o_xpm);
  iconMake = new QPixmap(make_xpm);
  iconResource = new QPixmap(resource_xpm);
  iconLog = new QPixmap(log_xpm);
  iconPs = new QPixmap(ps_xpm);
  iconPdf = new QPixmap(pdf_xpm);
  iconFilm = new QPixmap(film_xpm);
  iconSound = new QPixmap(sound_xpm);
  iconJava = new QPixmap(java_xpm);
  iconConfigs = new QPixmap(configs_xpm);
  iconUp = new QPixmap(up_xpm);
  iconHome = new QPixmap(home_xpm);
  iconSfile = new QPixmap(s_file_xpm);
  iconFolder = new QPixmap(folder1_xpm);
  iconSfolder = new QPixmap(s_folder_xpm);

  bgpixmap = new QPixmap(bgPixmap_xpm);
}
kcFileIconProvider::~kcFileIconProvider()
{
}
QPixmap *kcFileIconProvider::getUnknown()
{
  return iconUnknown;
}
QPixmap *kcFileIconProvider::getIcon(QString fileName)
{
	if(fileName == "unknown")   return iconUnknown ;
	if(fileName == "sfile")     return iconSfile ;
	if(fileName == "folder")    return iconFolder ;
	if(fileName == "sfolder")   return iconSfolder ;
	if(fileName == "back")   return iconUp ;
	if(fileName == "home")   return iconHome ;
	
	QFileInfo info(fileName);

	QString ext_true(info.extension(true));
	ext_true = ext_true.lower();
	QString ext_false(info.extension(false));
	ext_false = ext_false.lower();
	
	  	if( ext_false == "jpg" ||
	    ext_false == "jpeg" ||
	    ext_false == "png" ||
	    ext_false == "bmp" ||
	    ext_false == "xpm" ||
	    ext_false == "gif")    return iconPicture;
    	
	  	if( ext_false == "gz" ||
	        ext_false == "zip" ||
	        ext_false == "tar" ||
	        ext_false == "bz2" ||
	        ext_false == "tgz" ||
	        ext_false == "ace" ||
	        ext_false == "rar")
	      return iconPacked;
	
  	if( ext_false == "html" ||
	    ext_false == "htm" ||
	    ext_false == "php" ||
	    ext_false == "php3" ||
	    ext_false == "xml")   return iconWeb;

	if( ext_false == "rpm" ||
	    ext_false == "deb")   return iconRpm;
	
	if( ext_false == "txt" ||
	    ext_false == "rtf")   return iconText;
	
	if( ext_false == "cpp" || ext_false == "c") return iconCpp;
	
	if( ext_false == "doc")   return iconDoc;
	
	if( ext_false == "h")     return iconH;
	
	if( ext_false == "moc")   return iconMoc;
	
	if( ext_false == "o")     return iconO;
	
	if(info.baseName() == "Makefile")
	                          return iconMake;
	
	if( ext_false == "inc" ||
	    ext_false == "in" ||
	    ext_false == "m4" ||
	    ext_false == "am")    return iconResource;
	
	if(ext_false == "log" ||
	   ext_false == "Log")    return iconLog;
	
	if( ext_false == "ps" ||
	    ext_false == "gv")    return iconPs;
	
	if(ext_false == "pdf")    return iconPdf;
	
	if( ext_false == "avi" ||
	    ext_false == "mpg" ||
	    ext_false == "mpeg")  return iconFilm;
	
	if( ext_false == "class" ||
	    ext_false == "js" ||
	    ext_false == "java")  return iconJava;
	
	if( ext_false == "mp3" ||
	    ext_false == "wav" ||
	    ext_false == "mid" ||
	    ext_false == "sid" ||
	    ext_false == "snd")   return iconSound;

	if( ext_false == "conf")     return iconConfigs;
	
	if(info.extension() == "")
	{
	  return iconUnknown;
	}
	
  return iconUnknown;
}

// Als Extra fuer den FileOpenDialog damit er hier auch ordentliche Icons nimmt !!
const QPixmap * kcFileIconProvider::pixmap ( const QFileInfo & info )
{
  if(info.fileName() == "..") return iconUp ;
  if(info.isDir()) return iconFolder;

	QString ext_true(info.extension(true));
	ext_true = ext_true.lower();
	QString ext_false(info.extension(false));
	ext_false = ext_false.lower();
	
	  	if( ext_false == "jpg" ||
	    ext_false == "jpeg" ||
	    ext_false == "png" ||
	    ext_false == "bmp" ||
	    ext_false == "xpm" ||
	    ext_false == "gif")    return iconPicture;
    	
	  	if( ext_false == "gz" ||
	        ext_false == "zip" ||
	        ext_false == "tar" ||
	        ext_false == "bz2" ||
	        ext_false == "tgz" ||
	        ext_false == "ace" ||
	        ext_false == "rar")
	      return iconPacked;
	
  	if( ext_false == "html" ||
	    ext_false == "htm" ||
	    ext_false == "php" ||
	    ext_false == "php3" ||
	    ext_false == "xml")   return iconWeb;

	if( ext_false == "rpm" ||
	    ext_false == "deb")   return iconRpm;
	
	if( ext_false == "txt" ||
	    ext_false == "rtf")   return iconText;
	
	if( ext_false == "cpp")   return iconCpp;
	
	if( ext_false == "doc")   return iconDoc;
	
	if( ext_false == "h")     return iconH;
	
	if( ext_false == "moc")   return iconMoc;
	
	if( ext_false == "o")     return iconO;
	
	if(info.baseName() == "Makefile")
	                          return iconMake;
	
	if( ext_false == "inc" ||
	    ext_false == "in" ||
	    ext_false == "m4" ||
	    ext_false == "am")    return iconResource;
	
	if(ext_false == "log" ||
	   ext_false == "Log")    return iconLog;
	
	if( ext_false == "ps" ||
	    ext_false == "gv")    return iconPs;
	
	if(ext_false == "pdf")    return iconPdf;
	
	if( ext_false == "avi" ||
	    ext_false == "mpg" ||
	    ext_false == "mpeg")  return iconFilm;
	
	if( ext_false == "class" ||
	    ext_false == "js" ||
	    ext_false == "java")  return iconJava;
	
	if( ext_false == "mp3" ||
	    ext_false == "wav" ||
	    ext_false == "mid" ||
	    ext_false == "sid" ||
	    ext_false == "snd")   return iconSound;

	if( ext_false == "conf")     return iconConfigs;
	
	if(info.extension() == "")
	{
	  return iconUnknown;
	}
	
  return iconUnknown;
}

QPixmap kcFileIconProvider::getAppPixmap(QString fileName)
{
	if(fileName == "mail") return QPixmap((const char **)mail_xpm) ;
	if(fileName == "archiv") return QPixmap((const char **)packed_xpm) ;
	
	if(fileName == "filenew") return QPixmap((const char **)filenew_xpm) ;
	if(fileName == "fileopen") return QPixmap((const char **)fileopen_xpm) ;
	if(fileName == "filesave") return QPixmap((const char **)filesave_xpm) ;
	if(fileName == "fileprint") return QPixmap((const char **)fileprint_xpm) ;
	
	if(fileName == "editundo") return QPixmap((const char **)editundo_xpm) ;
	if(fileName == "editredo") return QPixmap((const char **)editredo_xpm) ;
	if(fileName == "editcopy") return QPixmap((const char **)editcopy_xpm) ;
	if(fileName == "editcut") return QPixmap((const char **)editcut_xpm) ;
	if(fileName == "editpaste") return QPixmap((const char **)editpaste_xpm) ;

	if(fileName == "textbold") return QPixmap((const char **)textbold_xpm) ;
	if(fileName == "textitalic") return QPixmap((const char **)textitalic_xpm) ;
	if(fileName == "textunder") return QPixmap((const char **)textunder_xpm) ;
	if(fileName == "textleft") return QPixmap((const char **)textleft_xpm) ;
	if(fileName == "textcenter") return QPixmap((const char **)textcenter_xpm) ;
	if(fileName == "textright") return QPixmap((const char **)textright_xpm) ;
	if(fileName == "textjustify") return QPixmap((const char **)textjustify_xpm) ;
	
	if(fileName == "paint") return QPixmap((const char **)picture_xpm) ;
	
// For Toolbars and others 	
	if(fileName == "kc") return QPixmap((const char **)kcpixmap) ;
	if(fileName == "reload") return QPixmap((const char **)reload_xpm) ;
	if(fileName == "config") return QPixmap((const char **)configure_xpm) ;
	if(fileName == "symlink") return QPixmap((const char **)s_file_xpm) ;
	if(fileName == "listView")  return QPixmap((const char **)listView_xpm) ;
	if(fileName == "iconView")  return QPixmap((const char **)iconView_xpm) ;
	if(fileName == "invert")  return QPixmap((const char **)invertselection_xpm) ;
	if(fileName == "rename")  return QPixmap((const char **)editclear_xpm) ;
	
	if(fileName == "bgPixmap")  return QPixmap((const char **)bgPixmap_xpm) ;
}

QPixmap kcFileIconProvider::getPixmap(QString fileName)
{
	if(fileName == "unknown")   return QPixmap((const char **)unknown_xpm) ;
	if(fileName == "sfile")     return QPixmap((const char **)s_file_xpm) ;
	if(fileName == "folder")    return QPixmap((const char **)folder1_xpm) ;
	if(fileName == "sfolder")   return QPixmap((const char **)s_folder_xpm) ;
	if(fileName == "listView")  return QPixmap((const char **)listView_xpm) ;
	if(fileName == "iconView")  return QPixmap((const char **)iconView_xpm) ;
	
	QFileInfo info(fileName);
	QString ext_true(info.extension(true));
	QString ext_false(info.extension(false));
	

	if(info.extension() == "")
	{
	  return QPixmap((const char **)unknown_xpm);
	}
	
  QRegExp rx;
  rx.setPattern( "\\b(JPG|jpg|jpeg|png|bmp|xpm|gif)\\b" );
  int res = rx.search(ext_true);
  if(res != -1)
    return QPixmap((const char **)picture_xpm);
    	
  rx.setPattern("\\b(gz|ace|zip|tar|bz2|rar|tgz)\\b");
  if(rx.search(ext_true) != -1) return QPixmap((const char **)packed_xpm);
	
	if( ext_false == "html" ||
	    ext_false == "htm" ||
	    ext_false == "php" ||
	    ext_false == "php3" ||
	    ext_false == "xml")
      	  return QPixmap((const char **)web_xpm);

	if( ext_false == "rpm" ||
	    ext_false == "deb")
	  return QPixmap((const char **)rpm_xpm);
	
	if( ext_false == "txt" ||
	    ext_false == "rtf")
	  return QPixmap((const char **)txt_xpm);
	if(ext_false == "cpp")
	  return QPixmap((const char **)cpp_xpm);
	
	if(ext_false == "doc")
	  return QPixmap((const char **)doc_xpm);
	
	if(ext_false == "h")
	  return QPixmap((const char **)h_xpm);
	
	if(ext_false == "moc")
	  return QPixmap((const char **)moc_xpm);
	
	if(ext_false == "o")
	  return QPixmap((const char **)o_xpm);
	
	if(info.baseName() == "Makefile")
	  return QPixmap((const char **)make_xpm);
	
	if( ext_false == "inc" ||
	    ext_false == "in" ||
	    ext_false == "m4")
    	  return QPixmap((const char **)resource_xpm);
	
	if(ext_false == "log")
	      return QPixmap((const char **)log_xpm);
	
	if( ext_false == "ps" ||
	    ext_false == "gv")
	      return QPixmap((const char **)ps_xpm);
	
	if(ext_false == "pdf")
	      return QPixmap((const char **)pdf_xpm);
	
	if( ext_false == "avi" ||
	    ext_false == "mpg" ||
	    ext_false == "mpeg")
    	  return QPixmap((const char **)film_xpm);
	
	if( ext_false == "mp3" ||
	    ext_false == "wav" ||
	    ext_false == "mid" ||
	    ext_false == "sid" ||
	    ext_false == "snd")
    	  return QPixmap((const char **)sound_xpm);

  return QPixmap((const char **)unknown_xpm);
}

