/***************************************************************************
                          kcfileiconprovider.h  -  description
                             -------------------
    begin                : Wed Dec 26 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/

#ifndef KCFILEICONPROVIDER_H
#define KCFILEICONPROVIDER_H

#include <qpixmap.h>
#include <qfileinfo.h>
#include <qfiledialog.h>

/**
  *@author Christian Fricke & Ren Mrten
  */
class kcFileIconProvider :public QFileIconProvider
{
public: 
	/** Konsturktor */
	kcFileIconProvider();
	/** Destructor */
	~kcFileIconProvider();
	
	/** Liefert Icon fuer unbekannten Filetyp zurueck */
	QPixmap *getUnknown();
	
	/** Liefert zu einem Filenamen das "richtige" Icon
	* funktioniert im Moment noch nach Fileendungen
	*/
  QPixmap *getIcon(QString);

	//! Liefert zu einem Fileinfo das "richtige" Icon
	/*! Das Ganze funktioniert im Moment noch nach Fileendungen.
	* \param   QFileInfo fileInfo-vom-File
	* \return  QPixmap*
	*/
  virtual const QPixmap * pixmap ( const QFileInfo & info );

	/** Pseudo fuer schnellen Zugriff auf temporaere Dinge
	* nicht geeignet fuer Listviews etc weil zu langsam
	*/
	static QPixmap getPixmap(QString);
	
	/** Wird von den einzelnen Funktionen und Teilprogrammen wie Viewer oder Editor
	* benutzt um Menues und Toolbars mit Icons zu versorgen
	*/
	static QPixmap getAppPixmap(QString);
};

#endif
