kcIconViewItem::kcIconViewItem(kcIconView *parent) : QIconViewItem((QIconView *)parent)
{
}
kcIconViewItem::kcIconViewItem(
                const struct_fileinfo *fi,
                kcIconView *parent, QIconViewItem *after, const QString &text)
                 : QIconViewItem((QIconView *)parent,after,text)
{
  iconFlag = false;
  iconView = parent;
  finfo = (struct_fileinfo *)fi;
  _fullPath = fi->_directoryname;
  if(_fullPath.right(1) != "/")
    _fullPath += "/";
  _fullPath += fi->_fileName;

  setText(fi->_fileName);
  setRenameEnabled(true);
}

kcIconViewItem::~kcIconViewItem(){
}

int kcIconViewItem::compare(QIconViewItem * i) const
{
  kcIconViewItem *li = (kcIconViewItem *)i;
  // TEST

  if(i->key() == "..")
      return 1;
  if(key() == "..")
      return -1;

  if(isFile() && li->isDir())
      return 1;

  if(isDir() && li->isFile())
      return -1;

  return key().localeAwareCompare( i->key());
}
bool kcIconViewItem::isFile() const
{
  return finfo->_isFile;
}
QDateTime kcIconViewItem::lastModified() const
{
  return finfo->_lastModified;
}
bool kcIconViewItem::isDir() const
{
  return finfo->_isDir;
}
bool kcIconViewItem::isSymLink() const
{
  return finfo->_isSymLink;
}
bool kcIconViewItem::isReadable() const
{
  return finfo->_isReadable;
}
uint kcIconViewItem::fileSize() const
{
  return finfo->_fileSize;
}
int kcIconViewItem::permissions() const
{
  return finfo->_permissions;
}

void kcIconViewItem::paintItem( QPainter *p, const QColorGroup &cg)
{
  QColorGroup cGroup( cg );
  cGroup.setColor( QColorGroup::Base, iconView->getBackgroundColor() );      //Base = Hintergrund  und  Text = Textfarbe !!
  cGroup.setColor( QColorGroup::Highlight, iconView->getHighlightColor());      //Highlight = Selected

//  if(index()%2 == 0)
//  {
//    cGroup.setColor( QColorGroup::Text, QColor(black) );      //Base = Hintergrund  und  Text = Textfarbe !!
//  }
//  else
//  {
//    cGroup.setColor( QColorGroup::Text, QColor(60,60,60));      //Base = Hintergrund  und  Text = Textfarbe !!
//  };
//
  if  ( isSymLink() )
  {
    QFont f( p->font() );
    f.setItalic(iconView->itemItalic);  // configurable
    f.setBold(iconView->itemBold);  // configurable
    p->setFont( f );
  }
  QIconViewItem::paintItem( p, cGroup);
}

QPixmap *kcIconViewItem::pixmap () const
{
  if(isDir())
  {
    if(isSymLink())
      return iconView->fip->getIcon("sfolder");
    else
     {
      if(finfo->_fileName == "..") return iconView->fip->getIcon("back");
      if(QDir::home().absPath() == QString(finfo->_directoryname+finfo->_fileName)) return iconView->fip->getIcon("home");
      return iconView->fip->getIcon("folder");
     }
  }
  else
  {  // FILE !!
    if(isSymLink())
    {
      return iconView->fip->getIcon("sfile");
    }
    else
      return iconView->fip->getIcon(_fullPath);
  }
}

QString kcIconViewItem::text () const
{
  return finfo->_fileName;
}
