/***************************************************************************
                          kcommander3.cpp  -  description
                             -------------------
    begin                : Die Dez 11 15:29:21 CET 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include <qvbox.h>
#include "kcommander3.h"
#include "filesave.xpm"
#include "fileopen.xpm"
#include "filenew.xpm"
#include "marble.xpm"
#include "metal.h"
#include <qworkspace.h>
#include <stdlib.h>

#include "kcfileiconprovider.h"
#include "dlgtar.h"
#include "inputbox.h"

KCommander3App::KCommander3App()
{
  setDockEnabled(Qt::DockLeft,false);
  setName("kcommander3");
  setCaption(tr("KCommander3 " VERSION));
  startTimer = new QTimer(this);
  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initActions();
//  initMenuBar();
  initToolBar();

//    QVBox* vb = new QVBox( this );
//    vb->setFrameStyle( QFrame::StyledPanel | QFrame::Sunken );
//
//    ws = new QWorkspace( vb );
//    ws->setScrollBarsEnabled( TRUE );
//    setCentralWidget( vb );

  initView();
  QSettings settings;
  int x,y,w,h;
  x = settings.readNumEntry( "/KCommander/geometry/x", 0);
  y = settings.readNumEntry( "/KCommander/geometry/y", 0);
  w = settings.readNumEntry( "/KCommander/geometry/width", 800 );
  h = settings.readNumEntry( "/KCommander/geometry/height", 480 );
  if(w<800)
    w = 800;
  if(h<480)
    h = 480;
  setGeometry(x,y,w,h);

  leftDialog = view->getLeftDialog();
  rightDialog = view->getRightDialog();

  connect( startTimer, SIGNAL(timeout()), SLOT(startReading()));
  startTimer->start( 100, TRUE ); // 2 seconds single-shot timer

    qApp->setStyle( new MetalStyle );
//    qApp->setFont( appFont, TRUE );
  QToolTip::setGloballyEnabled ( settings.readBoolEntry("/KCommander/Show Tooltips",true));
}
void KCommander3App::startReading()
{
  QSettings settings;
  bool visited = settings.readBoolEntry("/KCommander/Save Visited",true);

  QString dir(settings.readEntry(QString("/KCommander/Defaults/Left Dir/"), "/"));
//Patch
  if(visited && dir.find("tar.gz") == -1 && dir.find(".tgz") == -1 && dir.find(".zip") == -1)
    leftDialog->setDir(dir);
  else
    leftDialog->setDir(QDir::home().absPath());
//Patch-Ende
  settings.writeEntry(QString("/KCommander/Defaults/Left Dir/"), dir);
  dir = settings.readEntry(QString("/KCommander/Defaults/Right Dir/"), QDir::home().absPath());
//Patch
  if(visited && dir.find("tar.gz") == -1 && dir.find(".tgz") == -1 && dir.find(".zip") == -1)
  {
    rightDialog->setDir(dir);
  }
  else
    rightDialog->setDir(QDir::home().absPath());

//Patch-Ende
  settings.writeEntry(QString("/KCommander/Defaults/Right Dir/"), dir);
}
void KCommander3App::initView()
{
    setMinimumSize(400,200);
    view = new kcommander3view(this,"CentralView");
    view->setCaption("KCommander");
    view->showMaximized();
    this->setCentralWidget(view);
}

void KCommander3App::SetCentralWidget(QWidget *)
{
}

KCommander3App::~KCommander3App()
{
}

/** initializes all QActions of the application */
void KCommander3App::initActions(){

  // Men Initialisierung
//  menuBar()->setBackgroundPixmap(QPixmap(marble_xpm));

  // menuBar entry fileMenu
  fileMenu=new QPopupMenu();
  selectMenu=new QPopupMenu();
  selectMenu->insertSeparator();
  optionsMenu=new QPopupMenu();
  optionsMenu->insertSeparator();
  // menuBar entry helpMenu
  helpMenu=new QPopupMenu();

  // Alle Mengrafiken
  QPixmap openIcon, saveIcon, newIcon;
  newIcon = QPixmap(filenew);
  openIcon = QPixmap(fileopen);
  saveIcon = QPixmap(filesave);

  // FILE MENU
  QAction *ac;
  ac =  new QAction( tr("File properties"), kcFileIconProvider::getAppPixmap("config"), tr("File properties"),Key_Return + CTRL,this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotFileProperties()));
  ac->addTo(fileMenu);

  ac =  new QAction( tr("Archivate files"), kcFileIconProvider::getAppPixmap("archiv"), tr("Compress"),Key_F5 + CTRL,this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotFileArchivate()));
  ac->addTo(fileMenu);

  ac =  new QAction( tr("Mail file"), kcFileIconProvider::getAppPixmap("mail"), tr("Send as mail"),QAccel::stringToKey(("Ctrl+S")),this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotSendFileAsMail()));
  ac->addTo(fileMenu);

  // SONSTIGES
  rereadSource = new QAction(tr("ReReadSource_ctrl_R"), tr("&ReReadSource"), QAccel::stringToKey(("Ctrl+R")), this);
  connect(rereadSource, SIGNAL(activated()), this, SLOT(slotrereadSource()));

  rereadSource = new QAction(tr("ReReadSource"), newIcon, tr("&ReReadSource"), QAccel::stringToKey(("F2")), this);
  connect(rereadSource, SIGNAL(activated()), this, SLOT(slotrereadSource()));

  changeLists = new QAction(tr("changeLists_ctrl_U"), newIcon, tr("&ChangeLists"), QAccel::stringToKey(("Ctrl+U")), this);
  connect(changeLists, SIGNAL(activated()), this, SLOT(slotChangeLists()));

  // SELECT MENU
  // "+"
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("Select group"), QAccel::stringToKey("+"), this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotNumPlus()));
  ac->addTo(selectMenu);
  // "-"
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("Unselect group"), QAccel::stringToKey("-"), this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotNumMinus()));
  ac->addTo(selectMenu);
  // "STRG +"
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("Select all"), Key_Plus + CTRL, this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotCTRLNumPlus()));
  ac->addTo(selectMenu);
  // "STRG -"
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("Unselect all"), Key_Minus + CTRL, this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotCTRLNumMinus()));
  ac->addTo(selectMenu);
  // "STRG *"
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("Invert selection"), QAccel::stringToKey("*"), this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotInvertSelection()));
  ac->addTo(selectMenu);

  // Optionsmenu
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("General options"), Key_O + CTRL, this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotOptions()));
  ac->addTo(optionsMenu);
  ac =  new QAction( tr("Menu Item"), saveIcon, tr("Adressbook"), Key_A + CTRL, this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotAdrBook()));
  ac->addTo(optionsMenu);


  helpAboutApp = new QAction(tr("Help"), newIcon, tr("&Help"), QAccel::stringToKey(tr("F1")), this);
  helpAboutApp->setWhatsThis(tr("Help"));
  connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));
  helpAboutApp->addTo(helpMenu);
  mailUs = new QAction(tr("Send us a mail"), kcFileIconProvider::getAppPixmap("mail"), tr("&Send us a mail"), Key_M +CTRL, this);
  mailUs->setWhatsThis(tr("So you can send us whislist or what you want"));
  connect(mailUs, SIGNAL(activated()), this, SLOT(slotMailUs()));
  mailUs->addTo(helpMenu);

  // MENUBAR einbinden
  menuBar()->insertItem(tr("&File"), fileMenu) ;

  menuBar()->insertItem(tr("&Mark"), selectMenu);
  menuBar()->insertItem(tr("&Configuration"), optionsMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Help"), helpMenu);

}

void KCommander3App::initToolBar()
{
  ///////////////////////////////////////////////////////////////////
  // TOOLBAR
  QAction *ac;

  fileToolbar = new QToolBar(this, "file operations");
  fileToolbar->addSeparator();
  ac =  new QAction( tr("Reread source"), kcFileIconProvider::getAppPixmap("reload"), tr("Reread source"), Key_R + CTRL, this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotRereadSource()));
  ac->addTo(fileToolbar);

  ac =  new QAction( tr("File properties"), kcFileIconProvider::getAppPixmap("config"), tr("File properties"),Key_Return + CTRL,this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotFileProperties()));
  ac->addTo(fileToolbar);

  fileToolbar->addSeparator();

  ac =  new QAction( tr("Full fileview"), kcFileIconProvider::getAppPixmap("listView"), tr("Full fileview"), Key_F1 + SHIFT, this,"fullView");
  connect(ac, SIGNAL(activated()), this, SLOT(slotToggleView()));
  ac->addTo(fileToolbar);

  ac =  new QAction( tr("Brief fileview"), kcFileIconProvider::getAppPixmap("iconView"), tr("Brief fileview"), Key_F2 + SHIFT, this,"iconView");
  connect(ac, SIGNAL(activated()), this, SLOT(slotToggleView()));
  ac->addTo(fileToolbar);

  fileToolbar->addSeparator();

  ac =  new QAction( tr("Invert selection"), kcFileIconProvider::getAppPixmap("invert"), tr("Invert selection"), 0, this);
  connect(ac, SIGNAL(activated()), this, SLOT(slotInvertSelection()));
  ac->addTo(fileToolbar);

  fileToolbar->addSeparator();

}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////


void KCommander3App::slotrereadSource()
{
  debug("ReRead");
  if(view->getActiveDialog())
    view->getActiveDialog()->reRead();

}

void  KCommander3App::slotChangeLists()
{
  view->changeLists();
}

void KCommander3App::slotHelpAbout()
{
  QMessageBox::about(this,tr("About..."),
                      tr("KCommander3\nVersion " VERSION "\n(c) 2001 by Christian Fricke & Ren Mrten") );
}

void KCommander3App::closeEvent(QCloseEvent *e)
{
  system(QString("rm -r /tmp/kcommander >/dev/null 2>&1"));

  QSettings settings;
  QString ask = settings.readEntry( "/KCommander/Ask Quit", "Yes");
  if(ask == "Yes")
  {
     switch( QMessageBox::information( this, "KCommander " VERSION,
           "Do you want to quit kcommander...\n"
           "Choose a answer!",
           "&Yes", "&No", "Never ask!",
           0,      // Enter == button 0
           2 ) )  // Escape == button 2
     {
       case 0:
           // Yes wa pressed
           savePrefs();
           e->accept();
           break;
       case 1:
           // No pressed
           e->ignore();
           break;
       case 2:
           // Never ask
           settings.writeEntry( "/KCommander/Ask Quit", "No");
           e->accept();
           break;
     }
  }
  else
  {
     savePrefs();
     e->accept();
  }
}
void KCommander3App::savePrefs()
{
    view->saveSplitterSizes(); // Schreibe Werte des Splitters

    QSettings settings;
    settings.writeEntry( "/KCommander/Version", VERSION );
    settings.writeEntry( "/KCommander/geometry/x", x() );
    settings.writeEntry( "/KCommander/geometry/y", y() );
    settings.writeEntry( "/KCommander/geometry/width", width() );
    settings.writeEntry( "/KCommander/geometry/height", height() );
}
void KCommander3App::testSlot()
{
//  hexEdit = new hexViewEdit("/home/killer/signaturen",true);
  hexEdit = new hexViewEdit("/home/killer/signaturen",false);

}
void KCommander3App::slotNumPlus()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->slotPlusPressed();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->slotPlusPressed();
  }
}
void KCommander3App::slotNumMinus()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->slotMinusPressed();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->slotMinusPressed();
  }
}
void KCommander3App::slotCTRLNumPlus()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->slotCTRL_PlusPressed();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->slotCTRL_PlusPressed();
  }
}
void KCommander3App::slotCTRLNumMinus()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->slotCTRL_MinusPressed();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->slotCTRL_MinusPressed();
  }
}

void KCommander3App::slotOptions()
{
  QSettings settings;
  dlgOptions *op = new dlgOptions();
  op->setData();
  op->exec();
  if(op->result() == QDialog::Accepted)
  {
    qApp->setStyle(new MetalStyle);
    view->settingsChanged();
    QToolTip::setGloballyEnabled ( settings.readBoolEntry("/KCommander/Show Tooltips",true));
  }
}

void  KCommander3App::slotInvertSelection()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
    {
      ((kcListView*)view->getActiveDialog()->listViewV())->slotInvertSelection();
      return;
    }
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
    {
      ((kcIconView*)view->getActiveDialog()->listViewV())->slotInvertSelection();
      return;
    }
  }
}

void  KCommander3App::slotToggleView()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()) && QString(sender()->name()) == "iconView")
    {
      ((kcListView*)view->getActiveDialog()->listViewV())->makeViewChange();
      return;
    }
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()) && QString(sender()->name()) == "fullView")
    {
      ((kcIconView*)view->getActiveDialog()->listViewV())->makeViewChange();
      return;
    }
  }
}
void  KCommander3App::slotFileProperties()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->makePropertiesForFileChange();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->makePropertiesForFileChange();
  }
}
void  KCommander3App::slotRereadSource()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->reRead();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->reRead();
  }
}

void KCommander3App::slotSendFileAsMail()
{
  if(view->getActiveDialog())
  {
    if(dynamic_cast<kcListView*>(view->getActiveDialog()->listViewV()))
      ((kcListView*)view->getActiveDialog()->listViewV())->sendFileAsMail();
    if(dynamic_cast<kcIconView*>(view->getActiveDialog()->listViewV()))
      ((kcIconView*)view->getActiveDialog()->listViewV())->sendFileAsMail();
  }
}

void KCommander3App::slotMailUs()
{
    QSettings settings;
    QString ask = settings.readEntry("/KCommander/Mail/Mailusername","none");
    if(ask == "none")
    {
    	QMessageBox::critical ( (QWidget *)this, "Mail", tr("No valid username given.\nTake a look at the optionsdialog \nand make the right informations please."), 0, 0 );
    	return;
    }
    QString ask1 = settings.readEntry("/KCommander/Mail/Mailserver","none");
    if(ask1 == "none")
    {
    	QMessageBox::critical ( (QWidget *)this, "Mail", tr("No valid mailserver given.\nTake a look at the optionsdialog \nand make the right informations please."), 0, 0 );
    	return;
    }

  mailComposer *c = new mailComposer();
  c->from->setText(ask);    // mit der Mailingliste geht das irgendwie noch nicht :(
  c->from->setEnabled(false);
  c->to->setText("cfricke@kcommander.org");    // mit der Mailingliste geht das irgendwie noch nicht :(
  c->to->setEnabled(false);
  c->subject->setText("KCommander mail");
  c->subject->setEnabled(false);
  c->resize(500,300);
  c->show();
}

void  KCommander3App::slotFileArchivate()
{
  if(view->getActiveDialog())
  {
    InputBox * input = new InputBox(this,"Compress","Name of archive","test");
    input->exec();
    if(! input->result()) return;
    KTar2 *dlgTar = new KTar2(view->getActiveDialog()->listViewV(),input->returnInput(),this);
    dlgTar->exec();
  }
  view->getActiveDialog()->reRead();
}

void  KCommander3App::slotAdrBook()
{
    ABCentralWidget *ab = new ABCentralWidget();
    ab->show();
}
