/****************************************************************************
** $Id: kcsmtp.h,v 1.7 2002/04/21 07:10:32 cfricke Exp $
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#ifndef SMTP_H
#define SMTP_H

#include <qobject.h>
#include <qstring.h>
#include <qfile.h>
#include <qprocess.h>

class QSocket;
class QTextStream;
class QDns;

/**
  *@author Christian Fricke & Ren Mrten
  */

class kcSmtp : public QObject
{
    Q_OBJECT

public:
    kcSmtp( const QString &, const QString &, const QString &, const QString & );
    kcSmtp( const QString &, const QString &, const QString & );
    ~kcSmtp();

signals:
    void finished();
    void status( const QString & );

private slots:
    void readyRead();
    void readyReadForFile();
    void connected();
    void deleteMe();
    void dnsLookupHelper();

    void popLogin();
    void prepareFile(QString);
    void writeFile(QTextStream &);

  	//! Slot fuer das Signal QSocket::bytesWritten
	/*! Wird benoetigt um herauszufinden, wann er denn nun wirklich was geschrieben hat und wieviel.
	*  Lange Mails machen Probleme, wenn man an der richtigen Stelle nicht wartet.
	* \return  void
	*/
    void socketHadWritten(int);

private:
    enum State {
	Init,
	Mail,
	Rcpt,
	Data,
	Body,
	Quit,
	Close,
	
	PopReady,
	User,
	Passwd,
    };

    bool  firstPopLogin;
    QString message;
    QString messagePart1, messagePart2;
    QString from;
    QString rcpt;
    QSocket *socket, *socketPop;
    QTextStream *t, *tPop;
    int state;
    unsigned int  fsize;
    int  statSize;
    QString response;
    QDns * mxLookup;

    QString userName;
    QString passwd;

    bool  socketWritten;
};

#endif
