
#ifndef KCTEXTVIEWER_H
#define KCTEXTVIEWER_H

#include <qwidget.h>
#include <qtextbrowser.h>
#include <qfile.h>
#include <qmainwindow.h>
#include <qsound.h> // was'n das?????????????
#include <qsound.h>
#include <qstatusbar.h>
#include <statuslineentry.h>

#include "kcimageviewer.h"
#include "hexviewedit.h"


/**class for viewing files as text or hexadezimal
  *@author Rene Mrten & Christian Fricke
  */

class kcTextViewer : public QMainWindow  {
   Q_OBJECT
public: 
	kcTextViewer(QString filename,int type=0, QWidget *parent=0, const char *name=0);
	~kcTextViewer();
private:
  QTextBrowser  *textviewer;
  ImageViewer   *imageviewer;
  hexViewEdit   *hexviewer;
  QStatusBar    *statusbar;
  // Verschiedene Items fr Statusline
  statusLineEntry *stat_fsize,
                  *stat_filepos;

  QString       file;
private slots:
  void          resizeEvent(QResizeEvent *e);
  void          closeEvent(QCloseEvent *e);
  void          mySlot();
  void          keyPressEvent(QKeyEvent *e);

	void	        showAsText();
	void	        showAsHex();
	void	        showAsPic();
  void          setInfo1(QString s);
  void          setInfo2(QString s);
signals:
  void          closed();
};

#endif
