/***************************************************************************
                          kcview.cpp  -  description
                             -------------------
    begin                : Sun Feb 10 2002
    copyright            : (C) 2002 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#include "kcview.h"


dlgSelect::dlgSelect(QWidget* parent,  const char* name)
    : QDialog( parent, name, true, 0 )
{
  setCaption(tr("File selection"));
  b1 = new kcSimpleButton(this);
  b1->setText(tr("OK"));
  b1->setGeometry(5,53,142,22);
  connect(b1, SIGNAL(clicked()), SLOT(okClicked()));

  b2 = new kcSimpleButton(this);
  b2->setText(tr("Cancel"));
  b2->setGeometry(152,53,142,22);
  connect(b2, SIGNAL(clicked()), SLOT(cancelClicked()));

  le = new QLineEdit(this);
  le->setGeometry(5,5,290,24);
  connect(le, SIGNAL(returnPressed()), SLOT(returnPressed()));

  CS = new QCheckBox(this);
  CS->setText(tr("case sensitive"));
  CS->setGeometry(5,30,290,20);

  Line = new QFrame( this, "Line1" );
//  Line->setProperty( "frameShape", (int)QFrame::HLine );
  Line->setFrameShadow( QFrame::Sunken );
  Line->setFrameShape( QFrame::HLine );
  Line->setGeometry(5,52,290,2);

  QSettings settings;
  QString exp = settings.readEntry(QString("/KCommander/DefaultSelection"), "*.*");
  le->setText(exp);
  le->selectAll();

  setMinimumSize(300,78);
  setMaximumSize(300,78);
}

void dlgSelect::okClicked()
{
  if(le->text() != "")
  {
    QSettings settings;
    settings.writeEntry(QString("/KCommander/DefaultSelection"), le->text());
  }
  accept();
}

void dlgSelect::cancelClicked()
{
  // with ESC we emulate the Cancel Button
  reject();
}

void dlgSelect::keyReleaseEvent(QKeyEvent *e)
{
}

void dlgSelect::returnPressed()
{
  // with ENTER we emulate the OK Button
  okClicked();
}

dlgSelect::~dlgSelect()
{
}
QString dlgSelect::resultString()
{
  return strdup(le->text());
}

kcView::kcView()
{
    fip = new kcFileIconProvider;
}
kcView::~kcView(){
}

QString kcView::getType()
{
  return "test" ;
}
